# README #

### Required packages for both applications are: ###

* ROS Fuerte: ardrone_autonomy, image_transport, cv_bridge, opencv2 
* OpenCV 2.4, RailwayImageProcess

## Railway Follower Application ##

This application uses an AR.Drone to autonomously fly above railway lines  using only the on-board sensors of the drone.

### How to use railway pkg collection ###

Place the drone between the rail lines facing the desired direction (in real life or in the simulator).
Next start the Detection node and than the flight controller node:
```
#!shell
	$ rosrun RailDetect railDetect
	$ rosrun RailFlyControl2 railFly
```


To rebuild the RailwayImageProcess library:
```
#!shell
	$ g++ `pkg-config --cflags opencv` -o RailwayImageProcess.o -c RailwayImageProcess.c `pkg-config --libs opencv`
	$ g++ RailwayImageProcess.o -Wall -g -shared -o RailwayImageProcess.so
	$ sudo cp RailwayImageProcess.so /usr/local/lib/libRailwayImageProcess.so
```

### RAILWAY DETECTOR NODE ###

This node detects the desired direction where the drone should fly. It has the img processing and estimation implemnted. 

### RAILWAY FOLLOWER NODE ###

The node controls the drone`s velocity, the uses a PID controller, tuneable from launchfile. 

## Corridor Follower Application ##

This application uses an AR.Drone to autonomously fly through hallway like environments by using only the  on-board sensors of the drone.

### How to use corridor pkg collection ###

First, place the drone facing the direction of the corridor on a landing pad.
Than start the nodes in the following order: corridor detector, flight controller, and data logger node:
```
#!shell
	$ rosrun Corridor corridorDetect
	$ rosrun CorridorFlyControl corridorFly
	$ rosrun DataLogger dataLog
``` 

### CORRIDOR DETECTER NODE ###

This node processes the images from the AR.Drone and also estimates the postin of the VP with a linear Kalman filter. To upgrade the estimater into Extanded Kalman Filter visit: 
https://sites.google.com/site/timecontroll/home/extended-kalman-filtering-with-opencv

### FLIGHT CONTROLLER NODE ###

This node sends the velocity commands to the AR.Dron in depending on published "fly_command" msg by the corridor pkg.

### DATA LOGGER NODE ###

The data logger node saves navigational data (time stamp, Vx, Vy, altitude, yaw rotation) to "nav.txt"
and VP obseravtion (position VP oservation X & Y, VP estimation of X & Y) is saved in the "imageProcess.txt".


### Contact ###
Elod Pall

https://sites.google.com/site/timecontroll/